#ifndef ASIOAUDIO_H
	#define ASIOAUDIO_H

#include "stdafx.h"
#include <Windows.h>
#include "ASIOHost.h"
#define DLLNAME ("ASIOHost.dll")

// Declare function pointers for the DLL
typedef int (__cdecl *LPASIOGETDEVICES)(char*, int);
typedef bool (__cdecl *LPASIOINIT)(HWND, int);
typedef void (__cdecl *LPASIOSHUTDOWN)(void);
typedef DWORD (__cdecl *LPASIOGETSAMPLERATE)(void);
typedef void (__cdecl *LPASIOSETSAMPLERATE)(DWORD);
typedef int (__cdecl *LPASIOGETPRIMARYBUFFERSIZESAMPLES)(void);
typedef BITDEPTH (__cdecl *LPGETBITDEPTH)(void);
typedef DWORD (__cdecl *LPASIOGETOUTPUTLATENTCY)(void);
typedef DWORD (__cdecl *LPASIOGETINPUTLATENTCY)(void);
typedef bool (__cdecl *LPASIOGETCHANNELNAME)(char*, int);
typedef int (__cdecl *LPGETMAXCHANNELS)(MODE);
typedef int (__cdecl *LPCREATEBUFFERS)(int, MODE);
typedef void (__cdecl *LPSETMAXVIRTUALBUFS)(int);
typedef int (__cdecl *LPGETMAXVIRTUALBUFS)(void);
typedef bool (__cdecl *LPCREATEVIRTUALCHN)(LPCHANNELVARS);
typedef void (__cdecl *LPCLOSEVIRTUALCHN)(int);
typedef bool (__cdecl *LPPRELOADBUFFERS)(int);
typedef bool (__cdecl *LPSTARTPLAY)(int);
typedef void (__cdecl *LPSTOPPLAY)(int);
typedef void (__cdecl *LPSETVOLUME)(int, int);
typedef int (__cdecl *LPGETVOLUME)(int);
typedef DWORD (__cdecl *LPGETPOSITION)(int);
typedef void (__cdecl *LPPAUSE)(int);
typedef void (__cdecl *LPRESUME)(int);

class ASIOAudio
{
public:
 ASIOAudio();
 ~ASIOAudio();
 bool GetInitResult(void);
 LPASIOGETDEVICES ASIOGetDevices;
 LPASIOINIT ASIOInit;
 LPASIOSHUTDOWN ASIOShutdown;
 LPASIOGETSAMPLERATE ASIOGetSampleRate;
 LPASIOSETSAMPLERATE ASIOSetSampleRate;
 LPASIOGETPRIMARYBUFFERSIZESAMPLES ASIOGetPrimaryBufferSizeSamples;
 LPGETBITDEPTH ASIOGetBitdepth;
 LPGETMAXCHANNELS ASIOGetMaxVirtualChannels;
 LPCREATEBUFFERS ASIOCreateBuffers;
 LPASIOGETOUTPUTLATENTCY ASIOGetOutputLatency;
 LPASIOGETINPUTLATENTCY ASIOGetInputLatency;
 LPASIOGETCHANNELNAME ASIOGetChannelName;
 LPSETMAXVIRTUALBUFS SetMaxVirtualBuffers;
 LPGETMAXVIRTUALBUFS GetMaxVirtualBuffers;
 LPCREATEVIRTUALCHN CreateVirtualChannel;
 LPCLOSEVIRTUALCHN CloseVirtualChannel;
 LPPRELOADBUFFERS PreLoadBuffers;
 LPSTARTPLAY StartPlay;
 LPSTOPPLAY StopPlay;
 LPSETVOLUME SetVolume;
 LPGETVOLUME GetVolume;
 LPGETPOSITION GetPosition;
 LPPAUSE Pause;
 LPRESUME Resume;
private:
 HINSTANCE hDLL;
 bool bInitResult;
 bool LoadClient(char *DLLName);
 void ReleaseClient(void);
};

typedef ASIOAudio *LPASIOAUDIO;

bool LoadASIOHost(LPASIOAUDIO *ppASIOAudio, HWND hwndApp, char *AppName);

#endif