#include "Stdafx.h"
#include "ASIOAudio.h"

// Implementation of the ASIOAudio class...
ASIOAudio::ASIOAudio()
{
 bInitResult = LoadClient(DLLNAME);
}

ASIOAudio::~ASIOAudio()
{
 ReleaseClient();
}

bool ASIOAudio::GetInitResult(void){return bInitResult;};

bool ASIOAudio::LoadClient(char *DLLName)
{
 hDLL = LoadLibraryA(DLLName); 
 if(hDLL == NULL)return false;
 ASIOGetDevices = (LPASIOGETDEVICES)GetProcAddress((HMODULE)hDLL, (LPCSTR)"ASIOGetDevices");
 if(ASIOGetDevices == NULL)return false;
 ASIOInit = (LPASIOINIT)GetProcAddress((HMODULE)hDLL, (LPCSTR)"ASIOInit");
 if(ASIOInit == NULL)return false;
 ASIOShutdown = (LPASIOSHUTDOWN)GetProcAddress((HMODULE)hDLL, (LPCSTR)"ASIOShutdown");
 if(ASIOShutdown == NULL)return false;
 ASIOSetSampleRate =  (LPASIOSETSAMPLERATE)GetProcAddress((HMODULE)hDLL, (LPCSTR)"ASIOSetSampleRate");
 if(ASIOSetSampleRate == NULL)return false;
 ASIOGetSampleRate =  (LPASIOGETSAMPLERATE)GetProcAddress((HMODULE)hDLL, (LPCSTR)"ASIOGetSampleRate");
 if(ASIOGetSampleRate == NULL)return false;
 ASIOGetPrimaryBufferSizeSamples = (LPASIOGETPRIMARYBUFFERSIZESAMPLES)GetProcAddress((HMODULE)hDLL, (LPCSTR)"ASIOGetPrimaryBufferSizeSamples");
 if(ASIOGetPrimaryBufferSizeSamples == NULL)return false;
 ASIOGetBitdepth = (LPGETBITDEPTH)GetProcAddress((HMODULE)hDLL, (LPCSTR)"ASIOGetBitdepth");
 if(ASIOGetBitdepth == NULL)return false;
 ASIOGetMaxVirtualChannels = (LPGETMAXCHANNELS)GetProcAddress((HMODULE)hDLL, (LPCSTR)"ASIOGetMaxVirtualChannels");
 if(ASIOGetMaxVirtualChannels == NULL)return false;
 ASIOCreateBuffers = (LPCREATEBUFFERS)GetProcAddress((HMODULE)hDLL, (LPCSTR)"ASIOCreateBuffers");
 if(ASIOCreateBuffers == NULL)return false;
 ASIOGetOutputLatency = (LPASIOGETOUTPUTLATENTCY)GetProcAddress((HMODULE)hDLL, (LPCSTR)"ASIOGetOutputLatency");
 if(ASIOGetOutputLatency == NULL)return false;
 ASIOGetInputLatency = (LPASIOGETINPUTLATENTCY)GetProcAddress((HMODULE)hDLL, (LPCSTR)"ASIOGetInputLatency");
 if(ASIOGetInputLatency == NULL)return false;
 ASIOGetChannelName = (LPASIOGETCHANNELNAME)GetProcAddress((HMODULE)hDLL, (LPCSTR)"ASIOGetChannelName");
 if(ASIOGetChannelName == NULL)return false;
 SetMaxVirtualBuffers = (LPSETMAXVIRTUALBUFS)GetProcAddress((HMODULE)hDLL, (LPCSTR)"SetMaxVirtualBuffers");
 if(SetMaxVirtualBuffers == NULL)return false;
 GetMaxVirtualBuffers = (LPGETMAXVIRTUALBUFS)GetProcAddress((HMODULE)hDLL, (LPCSTR)"GetMaxVirtualBuffers");
 if(GetMaxVirtualBuffers == NULL)return false;
 CreateVirtualChannel = (LPCREATEVIRTUALCHN)GetProcAddress((HMODULE)hDLL, (LPCSTR)"CreateVirtualChannel");
 if(CreateVirtualChannel == NULL)return false;
 CloseVirtualChannel = (LPCLOSEVIRTUALCHN)GetProcAddress((HMODULE)hDLL, (LPCSTR)"CloseVirtualChannel");
 if(CloseVirtualChannel == NULL)return false;
 PreLoadBuffers = (LPPRELOADBUFFERS)GetProcAddress((HMODULE)hDLL, (LPCSTR)"PreLoadBuffers");
 if(PreLoadBuffers == NULL)return false;
 StartPlay = (LPSTARTPLAY)GetProcAddress((HMODULE)hDLL, (LPCSTR)"StartPlay");
 if(StartPlay == NULL)return false;
 StopPlay = (LPSTOPPLAY)GetProcAddress((HMODULE)hDLL, (LPCSTR)"StopPlay");
 if(StopPlay == NULL)return false;
 SetVolume = (LPSETVOLUME)GetProcAddress((HMODULE)hDLL, (LPCSTR)"SetVolume");
 if(SetVolume == NULL)return false;
 GetVolume = (LPGETVOLUME)GetProcAddress((HMODULE)hDLL, (LPCSTR)"GetVolume");
 if(GetVolume == NULL)return false;
 GetPosition = (LPGETPOSITION)GetProcAddress((HMODULE)hDLL, (LPCSTR)"GetPosition");
 if(GetPosition == NULL)return false;
 Pause = (LPPAUSE)GetProcAddress((HMODULE)hDLL, (LPCSTR)"Pause");
 if(Pause == NULL)return false;
 Resume = (LPRESUME)GetProcAddress((HMODULE)hDLL, (LPCSTR)"Resume");
 if(Resume == NULL)return false;
 return true;
}

void ASIOAudio::ReleaseClient(void)
{
  if(hDLL != NULL)
  {
     FreeLibrary((HMODULE)hDLL);
	 hDLL = NULL;
  }
}


#define DEBUG_MSG_OUT // Comment this out if you don't want a debug message to pop up
bool LoadASIOHost(LPASIOAUDIO *ppASIOAudio, HWND hwndApp, char *AppName)
{
 LPASIOAUDIO lpASIOAudio;
 bool bSuccess = false;

 *ppASIOAudio = NULL;

 lpASIOAudio = (LPASIOAUDIO) new ASIOAudio();
 if(lpASIOAudio != NULL)
 {
    if(lpASIOAudio->GetInitResult())
    {
	   bSuccess = true;
    }
 }

#ifdef DEBUG_MSG_OUT
 if(!bSuccess)
 {
    MessageBoxA(hwndApp, "Can't interface with ASIO audio engine, or can't find ASIOHost.dll!!", AppName, 
                        MB_OK | MB_ICONEXCLAMATION);
 
 }
#endif

 *ppASIOAudio = lpASIOAudio;
 return bSuccess;
}

