#ifndef ASIOHOST_H
	#define ASIOHOST_H

#define WM_WANTS_RESET (WM_APP + 10)

typedef void (*LPPROCESSBUFFER) (LPBYTE, DWORD, DWORD);

typedef struct channelvars_tag
{
 int nVirtualChnNum;
 int nBufSizeSamples;
 LPPROCESSBUFFER pOutBufServiceProc;
 LPPROCESSBUFFER pInBufServiceProc;
 DWORD dwInstanceData;
 bool bUseDeviceBitWidthPlay;
 bool bUseDeviceBitWidthRecord;
 short reserved;
}ChannelVars, *LPCHANNELVARS;

typedef enum{MODE_NOT_SET=0, MONO_PLAY_ONLY, MONO_RECORD_ONLY, MONO_PLAY_RECORD, STEREO_PLAY_ONLY, STEREO_RECORD_ONLY, STEREO_PLAY_RECORD}MODE, *LPMODE;
typedef enum{BITDEPTH_NOT_SET=0, BITDEPTH_16BITS, BITDEPTH_24BITS, BITDEPTH_32BITS}BITDEPTH, *LPBITDEPTH;

#ifdef __cplusplus
extern "C" {
#endif

extern int ASIOGetDevices(char *pStrBuf, int bufsize);
extern bool ASIOInit(HWND hwndMain, int nDevNum);
extern void ASIOShutdown(void);
extern bool ASIOSetSampleRate(DWORD dwSampleRate);
extern DWORD ASIOGetSampleRate(void);
extern int ASIOGetPrimaryBufferSizeSamples(void);
extern BITDEPTH ASIOGetBitdepth(void);
extern int ASIOGetMaxVirtualChannels(MODE proposedMode);
extern int ASIOCreateBuffers(int nMaxVirtualChannels, MODE requestedMode);
extern DWORD ASIOGetOutputLatency(void);
extern DWORD ASIOGetInputLatency(void);
extern bool ASIOGetChannelName(char *name, int channel);
extern void SetMaxVirtualBuffers(int nMaxVirtualBuffers);
extern int GetMaxVirtualBuffers(void);
extern bool CreateVirtualChannel(LPCHANNELVARS pChannelVars);
extern void CloseVirtualChannel(int nVirtualChnNum);
extern bool PreLoadBuffers(int nVirtualChnNum);
extern bool StartPlay(int nVirtualChnNum);
extern void StopPlay(int nVirtualChnNum);
extern void SetVolume(int nVirtualChnNum, int level);
extern int GetVolume(int nVirtualChnNum);
extern DWORD GetPosition(int nVirtualChnNum);
extern void Pause(int nVirtualChnNum);
extern void Resume(int nVirtualChnNum);

#ifdef __cplusplus
}
#endif




#endif